<template>
  <CCardBody>
    <template>
      <CSelect
        addInputClasses="customChevron"
        label="Площадка"
        :options="platforms"
        :value.sync="logisticLeverage.platform"
      />
      <CInput
        label="Склад автозаказа"
        v-model="logisticLeverage.warehouse"
        :invalidFeedback="invalidWarehouseMessage"
        :isValid="isInvalidWarehouse"
      />
      <CInput
        label="Логистическое плечо, дней"
        v-model="logisticLeverage.logisticLever"
        :invalidFeedback="invalidLogisticLeverMessage"
        :isValid="isInvalidLogisticLever"
      />
      <div class="controlButton">
        <CButton
          color="danger"
          class="cancel mr-2"
          @click="onClose(false)"
        >
          Отмена
        </CButton>
        <CButton
          color="primary"
          class="save"
          @click="onClose(true)"
        >
          Сохранить
        </CButton>
      </div>
    </template>
  </CCardBody>
</template>

<script>
  import {mapGetters} from 'vuex';
  import fieldWarnings from "../../../../../constants/fieldWarnings";

  export default {
    name: "EditingLogisticLeverage",
    props: {
      logisticLeverageInfo: {
        // Информация о редактируемой строке таблицы
        type: Object,
        default() {
          return {};
        },
      },
    },
    data() {
      return {
        logisticLeverage: {},
        logisticLeverageCopy: {},
        warnings: {},
        defaultWarnings: {},
      }
    },
    computed: {
      isInvalidWarehouse() {
        return 'warehouse' in this.warnings ? false : null;
      },
      invalidWarehouseMessage() {
        return this.isInvalidWarehouse === false ? this.warnings.warehouse : '';
      },
      isInvalidLogisticLever() {
        return 'logisticLever' in this.warnings ? false : null;
      },
      invalidLogisticLeverMessage() {
        return this.isInvalidLogisticLever === false ? this.warnings.logisticLever : '';
      },
      ...mapGetters(['platforms']),
    },
    watch: {
      'logisticLeverage.warehouse'(warehouse) {
        const {message} = this.defaultWarnings.warehouse;
        this.checkFieldValidation('warehouse', warehouse, message);
      },
      'logisticLeverage.logisticLever'(logisticLever) {
        const {compareFunc} = this.defaultWarnings.logisticLever;
        this.checkFieldValidation('logisticLever', logisticLever, null, compareFunc);
      },
    },
    created() {
      this.setDefaultData();
      this.defaultWarnings = {
        warehouse: {message: fieldWarnings.emptyField},
        logisticLever: {compareFunc: this.logisticLeverCompareFunc},
      }
    },
    methods: {
      setDefaultData() {
        // Установка полученных из Props значений для последующего их редактирвоаня
        const {platform_id, name, logistic_lever} = this.logisticLeverageInfo;
        this.logisticLeverage = {
          platform: +platform_id,
          warehouse: name,
          logisticLever: logistic_lever,
        }
      },
      onClose(closeType) {
        if (closeType) {
          if (this.checkValidation()) {
            this.$emit('onClose', {closeType, data: this.logisticLeverage});
          }
        } else {
          this.$emit('onClose', {closeType});
        }
      },
      checkValidation() {
        // Проверка корректности данных в полях
        return Object.keys(this.warnings).length === 0;
      },
      checkFieldValidation(
        field, value, warningMessage, compareFunc,
      ) {
        // Проверка поля на валидность
        // field String - название поля
        // value String - значение поля
        // warningMessage String - Текст, показываемый если поле не прошло валидацию
        // compareFunc Function - Функция валидирования поля
        const compareResult = compareFunc ? compareFunc(value) : defaultCompare(value);
        if (compareResult) {
          if (field in this.warnings) {
            this.warnings[field] = compareResult;
          } else {
            this.$set(this.warnings, field, compareResult);
          }
        } else if (field in this.warnings) {
          this.$delete(this.warnings, field);
        }

        function defaultCompare(value) {
          return value === '' ? warningMessage : false;
        }
      },
      logisticLeverCompareFunc(logisticLever) {
        // Функция для валидации поля "Логистическое плечо, дней"
        const {numberOnlyField, tooLargeNumber, emptyField} = fieldWarnings;
        if (Number.isSafeInteger(+logisticLever)) {
          return logisticLever === '' ? emptyField : false;
        }
        return Number.isNaN(+logisticLever) ? numberOnlyField : tooLargeNumber;
      },
    },
  }
</script>
